package cn.ibizlab.businesscentral.core.base.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.base.domain.Task;
import cn.ibizlab.businesscentral.core.base.filter.TaskSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Task] 服务对象接口
 */
public interface ITaskService extends IService<Task>{

    boolean checkKey(Task et) ;
    Task getDraft(Task et) ;
    boolean save(Task et) ;
    void saveBatch(List<Task> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(Task et) ;
    void createBatch(List<Task> list) ;
    Task get(String key) ;
    boolean update(Task et) ;
    void updateBatch(List<Task> list) ;
    Page<Task> searchDefault(TaskSearchContext context) ;
    List<Task> selectByServiceid(String serviceid) ;
    void removeByServiceid(String serviceid) ;
    List<Task> selectBySlaid(String slaid) ;
    void removeBySlaid(String slaid) ;
    List<Task> selectByTransactioncurrencyid(String transactioncurrencyid) ;
    void removeByTransactioncurrencyid(String transactioncurrencyid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<Task> getTaskByIds(List<String> ids) ;
    List<Task> getTaskByEntities(List<Task> entities) ;

}


